#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define MAXDATA 1024
#define MAXCHAR 1024

main(int argc,char *argv[])
{
  int i,j;
  int ii;
  int imax1,imax2,timax;
  int iimax;
  int iloop;
  int jmin[MAXDATA];
  double x1[MAXDATA],y1[MAXDATA],x2[MAXDATA],y2[MAXDATA];
  double tx2[MAXDATA],ty2[MAXDATA];
  double fx1[MAXDATA],fy1[MAXDATA],fx2[MAXDATA],fy2[MAXDATA];
  double vecx,vecy;
  double d,dmin;
  double dlimit=1e-3;
  double dx,dy,ddx,ddy;
  FILE *fp;
  char line[MAXCHAR];
  double searchmax;

  int counter;

  if(argc != 4){
    fprintf(stderr,"Usage: matchpat file1 file2 max_radius\n");
    exit(0);
  }
  
  searchmax=20.0;
  sscanf(argv[3],"%lf",&searchmax);
  /*  fprintf(stderr,"%lf\n",searchmax); */

  /* Load Data */
  if((fp = fopen(argv[1],"r")) == NULL){
    fprintf(stderr,"Cannot open %s\n",argv[1]);
    exit(1);
  }
  i=0;
  while(fgets(line,MAXCHAR,fp)!=NULL){
    if(strncmp(line,"#",1)){
      sscanf(line,"%lf %lf",&x1[i],&y1[i]);
      i++;
    }
  }
  imax1=i;
  fclose(fp);
  
  if((fp = fopen(argv[2],"r")) == NULL){ 
    fprintf(stderr,"Cannot open %s\n",argv[2]);
    exit(1);
  }
  i=0;
  while(fgets(line,MAXCHAR,fp)!=NULL){
    if(strncmp(line,"#",1)){
      sscanf(line,"%lf %lf",&x2[i],&y2[i]);
      i++;
    }
  }
  imax2=i;
  fclose(fp);

  /* start loop for pattern matching */
  dx=0;dy=0;
  ddx=dlimit*2;ddy=dlimit*2;
  iloop=0;
  timax=imax2;
  for(i=0;i<timax;i++){
    tx2[i]=x2[i];
    ty2[i]=y2[i];
  }
  iimax=imax1;

  /* move all the x1/y1 data into fx1/fy1 */
  for(i=0;i<iimax;i++){
    fx1[i]=x1[i];
    fy1[i]=y1[i];
  }
  /* move all the x2/y2 data into tx2/ty2 */
  for(i=0;i<timax;i++){
    tx2[i]=x2[i];
    ty2[i]=y2[i];
  }
  
  while(fabs(ddx)>dlimit || fabs(ddy)>dlimit){
    /*    fprintf(stderr,"ddx=%f\tddy=%f\n",ddx,ddy); */
    timax=imax2;
    /* Pattern Matching */
    ii=0;  
    for(i=0;i<iimax;i++){
      /* fprintf(stderr,"%d,%lf,%lf\n",i,x1[i],y1[i]); */
      dmin=1e20;
      counter=0;
      for(j=0;j<timax;j++){
	d=(fx1[i]-tx2[j])*(fx1[i]-tx2[j])+(fy1[i]-ty2[j])*(fy1[i]-ty2[j]);
	/* if any point find within searchmax */
	if(d<dmin){
	  dmin=d;
	  jmin[i]=j;
	}
	if(d<searchmax*searchmax){
	  counter++;
	}
      }

      /* if only one object found within searchmax */
      if(counter==1){
	vecx+=((fx1[i]-tx2[jmin[i]])/((double) timax));
	vecy+=((fy1[i]-ty2[jmin[i]])/((double) timax));
	/* new array for x1 and x2*/
	x1[ii]=fx1[i];
	y1[ii]=fy1[i];
	/* pair array for x1 and x2*/
	fx2[ii]=tx2[jmin[i]];
	fy2[ii]=ty2[jmin[i]];
	ii++;
      }
      /*      if(counter>1){
	fprintf(stderr,"%d objects found within search radius %f\n",counter,searchmax);
      }  */

    }
    iimax=ii;
    timax=ii;
    
    /* move all the revised array into fx1/fy1 */
    for(i=0;i<iimax;i++){
      fx1[i]=x1[i];
      fy1[i]=y1[i];
      tx2[i]=fx2[i];
      ty2[i]=fy2[i];
    }
    
    /* Calculate Minimum dx,dy*/
    ddx=0;ddy=0;
    for(i=0;i<iimax;i++){
      /*      fprintf(stderr,"%lf,%lf\t%lf,%lf\n",vecx,vecy,fx2[i],fy2[i]); */
      ddx+=(fx1[i]-fx2[i])/((double) iimax);
      ddy+=(fy1[i]-fy2[i])/((double) iimax);
    }
    dx+=ddx;
    dy+=ddy;
    iloop++;
    fprintf(stderr,"%d  dx=%.2f dy=%.2f %f %f\n",iimax,dx,dy,ddx,ddy);  

    /* add ddx and ddy obtained in previous loop */
    for(i=0;i<timax;i++){
      tx2[i]+=ddx;
      ty2[i]+=ddy;
    }

  }

  fprintf(stdout,"%lf\t%lf\n",dx,dy);
  fprintf(stderr,"  Offset: x=%lf\ty=%lf\n",dx,dy);
}
